/////////////////////////////////////////////////////////////////

#include "ESPTelnetStream.h"

/////////////////////////////////////////////////////////////////

void ESPTelnetStream::handleInput() {
  char c = client.read();
  on_input(String(c));
}

/////////////////////////////////////////////////////////////////

int ESPTelnetStream::available() {
  if (client && isConnected()) {
    return client.available();
  } else {
    return 0;
  }
}

/////////////////////////////////////////////////////////////////

int ESPTelnetStream::read() {
  if (client && isConnected()) {
    return client.read();
  } else {
    return 0;
  }
}

/////////////////////////////////////////////////////////////////

int ESPTelnetStream::peek() {
  if (client && isConnected()) {
    return client.peek();
  } else {
    return 0;
  }
}

/////////////////////////////////////////////////////////////////

void ESPTelnetStream::flush() {
  return ESPTelnetBase::flush();
}

/////////////////////////////////////////////////////////////////

size_t ESPTelnetStream::write(uint8_t data) {
  return ESPTelnetBase::write(data);
}

/////////////////////////////////////////////////////////////////

size_t ESPTelnetStream::write(const uint8_t* data, size_t size) {
  return ESPTelnetBase::write(data, size);
}

/////////////////////////////////////////////////////////////////